#include "1-Wire.h"
#include "init.h"

#define   T_SENS_DOWN    GPIOA->CRH |= GPIO_CRH_MODE10_1 | GPIO_CRH_CNF10_0; GPIOA->ODR &= ~GPIO_Pin_10;
#define   T_SENS_FREE    GPIOA->ODR |= GPIO_Pin_10; GPIOA->CRH &= ~GPIO_CRH_CNF10
#define   T_SENS_STAT    (GPIOA->IDR & GPIO_Pin_10)

unsigned int One_Wire_Reset()
{
	   uint8_t status;
	   T_SENS_DOWN;
	   _Delay_us(480);
	   T_SENS_FREE;
	   _Delay_us(66);
	   status = T_SENS_STAT;
	   T_SENS_FREE;
	   _Delay_us(414);
	   return status;
}

void One_Wire_Write_Byte(unsigned char Byte)
{
	unsigned char cnt;
	for (cnt = 0; cnt != 8; cnt++) One_Wire_Write_Bit(Byte&(1<<cnt));
}

void One_Wire_Write_Bit (unsigned char Bit)
{
	NVIC_DisableIRQ(TIM1_UP_TIM16_IRQn);

	T_SENS_DOWN;                          //   
	_Delay_us(1);

	if(Bit)T_SENS_FREE;                  //  1,   

	_Delay_us(60);

	T_SENS_FREE;                          // 

	NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);
} 

unsigned char One_Wire_Read_Bit()
{

	NVIC_DisableIRQ(TIM1_UP_TIM16_IRQn);

	uint8_t bit = 0;
	T_SENS_DOWN;
	_Delay_us(1);
	 T_SENS_FREE;
	_Delay_us(15);
	bit = (GPIOA->IDR&GPIO_Pin_10?1:0);
	_Delay_us(45);

	NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);

	return bit;//*/
}

unsigned char One_Wire_Read_Byte()
{
	unsigned char tmp = 0;
	unsigned char cnt;

	for (cnt = 0; cnt != 8; cnt++){
		if(One_Wire_Read_Bit(1)) tmp |= 1<<cnt;
	}

	return tmp;
}
