#include "init.h"
#include "1-wire.h"
#include "CRC.h"

#define DS1820_CONVERT_T_CMD				0x44
#define DS1820_WRITE_STRATCHPAD_CMD			0x4E
#define DS1820_READ_STRATCHPAD_CMD			0xBE

#define DS1820_STRATCHPAD_SIZE				0x09

// constant to convert the fraction bits to cel*(10^-4)
#define DS18X20_FRACCONV         625

#define DS18B20_CONF_REG    4
#define DS18B20_9_BIT       0
#define DS18B20_10_BIT      (1<<5)
#define DS18B20_11_BIT      (1<<6)
#define DS18B20_12_BIT      ((1<<6)|(1<<5))

// indefined bits in LSB if 18B20 != 12bit
#define DS18B20_9_BIT_UNDF       ((1<<0)|(1<<1)|(1<<2))
#define DS18B20_10_BIT_UNDF      ((1<<0)|(1<<1))
#define DS18B20_11_BIT_UNDF      ((1<<0))
#define DS18B20_12_BIT_UNDF      0

// conversion times in ms
#define DS18B20_TCONV_12BIT      750
#define DS18B20_TCONV_11BIT      DS18B20_TCONV_12_BIT/2
#define DS18B20_TCONV_10BIT      DS18B20_TCONV_12_BIT/4
#define DS18B20_TCONV_9BIT       DS18B20_TCONV_12_BIT/8
#define DS18S20_TCONV            DS18B20_TCONV_12_BIT

unsigned char DS1820_Start_Conv();
unsigned char DS1820_Get_Temp(uint8_t *temp_code, uint8_t *subzero, uint8_t *cel_frac_bits);
uint16_t DS1820_temp_to_decicel(uint8_t subzero, uint8_t cel, uint8_t cel_frac_bits);

