/*
 * init.c
 *
 *  Created on: 18 . 2015 .
 *      Author: BARS
 */

#include "init.h"

void GPIO_init(){
	 RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;
	 RCC->APB1ENR |= RCC_APB1ENR_I2C2EN;
	
	 AFIO->MAPR |= AFIO_MAPR_SWJ_CFG_JTAGDISABLE;

	 RCC->APB2ENR |= RCC_APB2ENR_IOPAEN | RCC_APB2ENR_IOPBEN;

	 SysTick_Config(24000);//1ms

/****************************************************************************************************************************/

	 // I/O INIT
	 GPIOB->CRL &= ~GPIO_CRL_CNF5; // LEDs1
	 GPIOB->CRL |=  GPIO_CRL_MODE5;

	 GPIOB->CRH &= ~GPIO_CRH_CNF9; // LEDs2
	 GPIOB->CRH |=  GPIO_CRH_MODE9;

	 GPIOA->CRH &= ~GPIO_CRH_CNF8 & ~GPIO_CRH_CNF9; // T1 T2
	 GPIOA->CRH |=  GPIO_CRH_MODE8 | GPIO_CRH_MODE9;

	 GPIOB->CRH &= ~GPIO_CRH_CNF15 & ~GPIO_CRH_CNF14 & ~GPIO_CRH_CNF13 & ~GPIO_CRH_CNF12; // T3 T4 T5 T6
	 GPIOB->CRH |=  GPIO_CRH_MODE15 | GPIO_CRH_MODE14 | GPIO_CRH_MODE13 | GPIO_CRH_MODE12;

	 GPIOB->CRL &= ~GPIO_CRL_CNF4 & ~GPIO_CRL_CNF3 & ~GPIO_CRL_CNF1;

	 GPIOB->CRL   &=  ~GPIO_CRL_MODE4 & ~GPIO_CRL_MODE3 & ~GPIO_CRL_MODE1; // BUT1 BUT2
	 GPIOB->CRL   |=  GPIO_CRL_CNF4_0 | GPIO_CRL_CNF3_0 | GPIO_CRL_CNF1_1; // CLOCK
	 //GPIOB->ODR |= GPIO_ODR_ODR1;

	 GPIOA->CRH   &=  ~GPIO_CRH_CNF15;
	 GPIOA->CRH   &=  ~GPIO_CRH_MODE15; // BUT3
	 GPIOA->CRH   |=  GPIO_CRH_CNF15_0;

	 GPIOA->CRL &= ~GPIO_CRL_CNF4 & ~GPIO_CRL_CNF5 & ~GPIO_CRL_CNF6 & ~GPIO_CRL_CNF7; // ID_A ID_B ID_C ID_D
	 GPIOA->CRL |=  GPIO_CRL_MODE4 | GPIO_CRL_MODE5 | GPIO_CRL_MODE6 | GPIO_CRL_MODE7;
/****************************************************************************************************************************/

	 //PWM INIT
	 GPIOB->CRL |= GPIO_CRL_MODE7;  //RED
	 GPIOB->CRL &= ~GPIO_CRL_CNF7;  //  CNF[1:0] (      "Input Floating")
	 GPIOB->CRL |= GPIO_CRL_CNF7_1; // Push-Pull    

	 GPIOB->CRH |= GPIO_CRH_MODE8;  //GREEN
	 GPIOB->CRH &= ~GPIO_CRH_CNF8;  //  CNF[1:0] (      "Input Floating")
	 GPIOB->CRH |= GPIO_CRH_CNF8_1; //  Push-Pull    

	 GPIOB->CRL |= GPIO_CRL_MODE6;  //BLUE
	 GPIOB->CRL &= ~GPIO_CRL_CNF6;  //  CNF[1:0] (      "Input Floating")
	 GPIOB->CRL |= GPIO_CRL_CNF6_1; // Push-Pull    

/****************************************************************************************************************************/

	 //I2C INIT
	 GPIOB->CRH   &= ~GPIO_CRH_MODE10 & ~GPIO_CRH_MODE11;      //  MODE
	 GPIOB->CRH   &= ~GPIO_CRH_CNF10 & ~GPIO_CRH_CNF11;       //  CNF
	 GPIOB->CRH   |=  GPIO_CRH_MODE10 | GPIO_CRH_MODE11;       //, 2MHz
	 GPIOB->CRH   |=  GPIO_CRH_CNF10 | GPIO_CRH_CNF11;     //   

	
/****************************************************************************************************************************/

	 // 1-Wire INIT
	 GPIOA->CRH   &= ~GPIO_CRH_MODE10;      //  MODE
	 GPIOA->CRH   &= ~GPIO_CRH_CNF10;       //  CNF
	 GPIOA->CRH   |=  GPIO_CRH_MODE10_1;    //, 2MHz
	 GPIOA->CRH   |=  GPIO_CRH_CNF10_0;     //   
}

void TIM_Init(){
	/*---------------------TIMER UPDATE DATA------------------------*/
	RCC->APB1ENR |= RCC_APB1ENR_TIM7EN;    //  TIM6

	RCC->APB2ENR |= RCC_APB2ENR_TIM1EN;

	TIM1->PSC = 1;
	TIM1->ARR = 250;//190; // 100
	TIM1->DIER |= TIM_DIER_UIE;
	TIM1->CR1 |= TIM_CR1_CEN;

	NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);

	/*-------------------TIMER LEDs LIGHT----------------------*/
	RCC->APB1ENR |= RCC_APB1ENR_TIM4EN;

    TIM4->CCER |=  TIM_CCER_CC1E | TIM_CCER_CC2E | TIM_CCER_CC3E;
    TIM4->CCMR1 |= TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1M_2;
    TIM4->CCMR1 |= TIM_CCMR1_OC2M_1 | TIM_CCMR1_OC2M_2;
    TIM4->CCMR2 |= TIM_CCMR2_OC3M_1 | TIM_CCMR2_OC3M_2;

    TIM4->CR1 |= TIM_CR1_CEN;

	RCC->APB1ENR |= RCC_APB1ENR_TIM6EN;

	TIM6->PSC = 24000;
	TIM6->ARR = 5; //
	TIM6->DIER |= TIM_DIER_UIE;

	TIM6->CR1 |= TIM_CR1_CEN;

	NVIC_EnableIRQ(TIM6_DAC_IRQn);


	RCC->APB1ENR |= RCC_APB1ENR_TIM2EN;

	TIM2->PSC = 24000; 
	TIM2->ARR = 900; //  
	TIM2->DIER |= TIM_DIER_UIE;

	NVIC_EnableIRQ(TIM2_IRQn);

    __enable_irq();
}

void ADC_Init(){

	// PORTB.8 -  
	GPIOA->CRL   &= ~GPIO_CRL_MODE3;       //  MODE
	GPIOA->CRL   &= ~GPIO_CRL_CNF3;        //  CNF

	RCC->CFGR    &= ~RCC_CFGR_ADCPRE;      // 
	RCC->CFGR |= RCC_CFGR_ADCPRE_DIV2;
	RCC->APB2ENR |=  RCC_APB2ENR_ADC1EN;   //  

	ADC1->SQR1    =  0;                    //

	ADC1->CR2    |=  ADC_CR2_EXTSEL;       //     SWSTART
	ADC1->CR2    |=  ADC_CR2_EXTTRIG;      //.    
	ADC1->SQR3   |=  ADC_SQR3_SQ1_1 | ADC_SQR3_SQ1_0;       //  

	ADC1->CR2    |=  ADC_CR2_ADON;         // 

	ADC1->CR2 |= ADC_CR2_CAL;
}

/****************************************************************/
volatile unsigned int SysTickDelay;


void _delay_ms(uint32_t Val)
{
	SysTickDelay = Val;
	while (SysTickDelay != 0) {};
}

//------------------------------------------------------------------------
void SysTick_Handler(void)
{
   if (SysTickDelay != 0)
   {
      SysTickDelay--;
   }
}
