/*
 * main.c
 *
 *  Created on: 15 . 2015 .
 *      Author: BARS
 */

#include "stm32f10x.h"

#include "main.h"
#include "init.h"
#include "flash.h"

#include "ds3231.h"

#include "1-Wire.h"
#include "DS1820.h"

#include "stdlib.h"

#define DELAY_TIME 60
#define DELAY_DATE 20
#define DELAY_TEMP 20

volatile uint8_t COLOR_CONST = 3;
volatile uint16_t TIME_CONST = 150;

const uint8_t dig1[11] = {
	 0b11010000, // 0
	 0b01000000, // 1
	 0b01010000, // 2
	 0b10010000, // 3
	 0b00000000, // 4
	 0b00100000, // 5
	 0b00110000, // 6
	 0b00010000, // 7
	 0b11000000, // 8
	 0b10000000  // 9
};

const uint8_t dig2[11] = {
	 0b01010000, // 0
	 0b01000000, // 1
	 0b11010000, // 2
	 0b10000000, // 3
	 0b00010000, // 4
	 0b00110000, // 5
	 0b00100000, // 6
	 0b00000000, // 7
	 0b10010000, // 8
	 0b11000000  // 9
};

volatile uint16_t R[2]={0, 0}, G[2]={0, 0}, B[2]={0, 0}, N[2] = {0, 0};

volatile uint8_t lamp = 0, l = 0, ch_val[6], count = 0, lev[6] = {0, 0, 0, 0, 0, 0}, digital[6] = {0,0,0,0,0,0};

volatile uint8_t H = 0, M = 0, S = 0, W = 0, m = 0, d = 0, y = 0, sec = 0;

uint8_t temp_code = 0, subzero = 0, cel_frac_bits = 0;
uint16_t L_Level = 0, s_data = 0, r_data = 0;

volatile uint8_t fr[2], tscr[6] = {10, 10, 10, 10, 10, 10}, st = 0, ready = 0, fad[2] = {0, 0}, run_cnt[7];
volatile uint8_t brig[2] = {127, 127}, brig_tmp[2] = {127, 127}, brig_cnt = 0, br = 0;
volatile uint16_t sl_time = 0, delay = 0, Temp = 0, Time_RD = 0, Temp_RD = 0;
volatile uint8_t set = 0, led[3] = {0, 1, 1}, screen = 0, lev_dir = 0, li_time = 0, col[2] = {0, 0}, col_change = 3, Ts = 0;

void display();
void display_ret();

uint16_t ADC_Read(){ //   
	ADC1->CR2 |= ADC_CR2_SWSTART;

	while (!(ADC1->SR & ADC_SR_EOC));

	return ADC1->DR;
}

//COLOR RR GG BB
//SET R L
//ADDR 123-126

void Flash_save(uint16_t data, uint8_t addr_byte, uint8_t addr_flash){ //    Flash
	uint16_t tmp_data = 0;

	tmp_data = flash_read(FLASH_BASE + addr_flash * 1024);

	if(addr_byte == 1){
		tmp_data &= ~0xFF00;
		tmp_data |= data << 8;
	}else
		if(addr_byte == 2){
			tmp_data &= ~0x00FF;
			tmp_data |= data;
		}else
			if(addr_byte == 3){
				tmp_data = data;
			}

	flash_erase_page(FLASH_BASE + addr_flash * 1024);
	flash_write(FLASH_BASE + addr_flash * 1024, tmp_data);
}

uint16_t Flash_read(uint8_t addr_flash){ //   Flash
	uint16_t data = 0;

	data = flash_read(FLASH_BASE + addr_flash * 1024);

	return data;
}

void soft(uint8_t DG1, uint8_t DG2, uint8_t DG3) { //     

 uint8_t j = 0;

 if(set == 0){
	tscr[0] = DG1 / 10; //   
	tscr[1] = DG1 % 10;
	tscr[2] = DG2 / 10;
	tscr[3] = DG2 % 10;
	tscr[4] = DG3 / 10;
	tscr[5] = DG3 % 10;

	for (j = 0; j < 6; j++){ //   ,  
		if (tscr[j] != digital[j]) //      
			fr[0] |= (1<<j); //  
	}
 }else{
	 fr[0] = 0; //      
	 fr[1] = 0;
 }
}

void TIM1_UP_TIM16_IRQHandler(){
 if(TIM1->SR & TIM_SR_UIF){
	TIM1->SR &= ~TIM_SR_UIF;

	if(fad[0] == 0)sl_time ++;

	if(sl_time >= TIME_CONST && fad[0] == 0){ //   
		fr[1] = fr[0];

		for(Ts = 0; Ts < 6; Ts++){
			if(fr[1] & 1){

				if(tscr[Ts] == 0 && digital[Ts] > 0){
					if(Ts == 5 || Ts == 3 || Ts == 1){
						run_cnt[6] = 4;
					}else
					if(Ts == 0){
						run_cnt[6] = 16;
					}else{
						run_cnt[6] = 7;
					}

					if(digital[Ts] > 0 && run_cnt[Ts]++ == run_cnt[6]){
						digital[Ts]--;
						run_cnt[Ts] = 0;
					}else{
						if(digital[Ts] == 0) fr[0] &= ~(1<<Ts);
					}
				}else{
					if(digital[Ts] != tscr[Ts]){
						lev[Ts] --;

						if(lev[Ts] == 0){
							digital[Ts] = tscr[Ts];
						}
					}else{
						lev[Ts] ++;

						if(lev[Ts] >= brig[0]){
							fr[0] &= ~(1<<Ts);
						}
					}
				}
			}
			fr[1] >>= 1;
		}
		sl_time = 0;
	}

	if(led[0] == 0){
		LEDs2_L;

		if(led[1] == 1){
			TIM4->CCR1 = R[0];
			TIM4->CCR2 = B[0];
			TIM4->CCR3 = G[0];

			LEDs1_H;
		}

		led[0] = 1;
	}else{
		LEDs1_L;

		if(led[2] == 1){
			TIM4->CCR1 = G[1];
			TIM4->CCR2 = R[1];
			TIM4->CCR3 = B[1];

			LEDs2_H;
		}

		led[0] = 0;
	}

	if(count == 0){ //   + 

		GPIOA->ODR &= ~ 0xF0;
		ch_val[0] = 0; ch_val[1] = 0; ch_val[2] = 0; ch_val[3] = 0; ch_val[4] = 0; ch_val[5] = 0;

		switch(l){
		case 0:
			ch_val[0] = lev[0]; GPIOA->ODR |= dig1[digital[0]]; l = 1;
		break;
		case 1:
			ch_val[1] = lev[1]; GPIOA->ODR |= dig1[digital[1]]; l = 2;
		break;
		case 2:
			ch_val[2] = lev[2]; GPIOA->ODR |= dig1[digital[2]]; l = 3;
		break;
		case 3:
			ch_val[3] = lev[3]; GPIOA->ODR |= dig1[digital[3]]; l = 4;
		break;
		case 4:
			ch_val[4] = lev[4]; GPIOA->ODR |= dig2[digital[4]]; l = 5;
		break;
		case 5:
			ch_val[5] = lev[5]; GPIOA->ODR |= dig2[digital[5]]; l = 0;
		break;
		}
	}

		if(count++ == 127){count = 0;}

		if(ch_val[0] > count){T1_H;}else{T1_L;}
		if(ch_val[1] > count){T2_H;}else{T2_L;}
		if(ch_val[2] > count){T3_H;}else{T3_L;}
		if(ch_val[3] > count){T4_H;}else{T4_L;}
		if(ch_val[4] > count){T5_H;}else{T5_L;}
		if(ch_val[5] > count){T6_H;}else{T6_L;}
	}
}

void TIM6_DAC_IRQHandler(){

 if(TIM6->SR & TIM_SR_UIF){

	TIM6->SR &= ~TIM_SR_UIF;

	if(fad[0] == 0 || fad[0] == 10){
		if(ready == 0){
			if(brig[0] > brig_tmp[0]){ //      

				for(br = 0; br < 6; br++){
					if(lev[br] > brig_tmp[0]){
						lev[br]--;
					}else{
						brig_cnt |= 1<<br;
					}
				}

				if(brig_cnt == 0x3F){
					brig[0] = brig_tmp[0];
					brig[1] = brig_tmp[0];
					brig_cnt = 0;

					TIME_CONST = 1000000/((brig[0])*2)/37;

					COLOR_CONST = 3 + (brig[1]-27)/3;
				}
			}else
				if(brig[0] < brig_tmp[0]){

					for(br = 0; br < 6; br ++){
						if(lev[br] < brig_tmp[0]){
							lev[br]++;
						}else{
							brig_cnt |= 1<<br;
						}
					}

					if(brig_cnt == 0x3F){
						brig[0] = brig_tmp[0];
						brig[1] = brig_tmp[0];
						brig_cnt = 0;

						TIME_CONST = 1000000/((brig[0])*2)/37;

						COLOR_CONST = 3 + (brig[1]-27)/3;
					}
				}
		}

		if((col_change & 1) && led[1] == 1){// R RG G GB B BR //    
			switch(col[0]){
			case 0: if(R[0] < brig[1]*200) R[0] += COLOR_CONST; else col[0] = 1; break; //R
			case 1: if(G[0] < brig[1]*152) G[0] += COLOR_CONST/2; else col[0] = 2; break; //RG
			case 2: if(R[0] > COLOR_CONST) R[0] -= COLOR_CONST; else col[0] = 3; break; //G
			case 3: if(B[0] < brig[1]*113) B[0] += COLOR_CONST; else col[0] = 4; break; //GB
			case 4: if(G[0] > COLOR_CONST) G[0] -= COLOR_CONST; else col[0] = 5; break; //B
			case 5: if(R[0] < brig[1]*200) R[0] += COLOR_CONST; else col[0] = 6; break; //BR
			case 6: if(B[0] > COLOR_CONST) B[0] -= COLOR_CONST; else col[0] = 7; break; //R
			case 7: if(N[0] < brig[1]*200){ N[0] += COLOR_CONST; }else{ col[0] = 1; N[0] = 0;} break;
			}
		}

		if((col_change & 2) && led[2] == 1){
			switch(col[1]){
			case 0: if(R[1] < brig[1]*511) R[1] += COLOR_CONST; else col[1] = 1; break;
			case 1: if(G[1] < brig[1]*390) G[1] += COLOR_CONST/2; else col[1] = 2; break;
			case 2: if(R[1] > COLOR_CONST) R[1] -= COLOR_CONST; else col[1] = 3; break;
			case 3: if(B[1] < brig[1]*290) B[1] += COLOR_CONST; else col[1] = 4; break;
			case 4: if(G[1] > COLOR_CONST) G[1] -= COLOR_CONST; else col[1] = 5; break;
			case 5: if(R[1] < brig[1]*511) R[1] += COLOR_CONST; else col[1] = 6; break;
			case 6: if(B[1] > COLOR_CONST) B[1] -= COLOR_CONST; else col[1] = 7; break;
			case 7: if(N[1] < brig[1]*511){ N[1] += COLOR_CONST; }else{ col[1] = 1; N[1] = 0;} break;
			}
		}
	}else

	if(fad[0] == 1){ //    
		if(fad[1] < 6){
			if(lev[fad[1]] > 0){
				lev[fad[1]] --;
			}else{
				fad[1] ++;
			}
		}else

		if(fad[1] == 6){
			Temp_RD = 1;
			fad[1] = 7;
		}else

		if(fad[1] > 6 && fad[1] <= 9){
			if(fad[1] == 7){
				digital[2] = Temp/100;
				digital[3] = Temp/10%10;
				digital[4] = Temp%10;
			}

			if(lev[fad[1]-5] < brig[0]){
				lev[fad[1]-5] ++;
			}else{
				fad[1] ++;
			}
		}
	}else
	if(fad[0] == 2){
		if(fad[1] > 6){
			if(lev[fad[1]-5] > 0){
				lev[fad[1]-5] --;
			}else{
				fad[1] --;
			}
		}else{
			if(fad[1] == 6){
				Time_RD = 1;

				digital[2] = tscr[2];
				digital[3] = tscr[3];

				fad[1] = 0;
			}

			if(lev[fad[1]] < brig[0]){
				lev[fad[1]] ++;
				lev[fad[1]+1] ++;
			}else{
				Time_RD = 1;

				digital[2] = tscr[2];
				digital[3] = tscr[3];
				digital[4] = tscr[4];
				digital[5] = tscr[5];

				fad[1] += 2;

				if(fad[1] == 6){
					delay = 0;

					Time_RD = 1;

					fad[0] = 0;
					fad[1] = 0;
				}
			}
		}
	}else
	if(fad[0] == 3 && sl_time++ >= 1){
		if(lev_dir == 0){
			if(lev[2] > 0){
				lev[2] --;
			}else
				if(lev[5] > 0){
					lev[5] --;
				}else
					if(lev[3] > 0){
						lev[3] --;
					}else
						if(lev[1] > 0){
							lev[1] --;
						}else
							if(lev[4] > 0){
								lev[4] --;
							}else
								if(lev[0] > 0){
									lev[0] --;
								}else{
									lev_dir = 1;

									digital[0] = d/10;
									digital[1] = d%10;
									digital[2] = m/10;
									digital[3] = m%10;
									digital[4] = y/10;
									digital[5] = y%10;
								}
		}else{
			if(lev[5] < brig[0]){
				lev[5] ++;
			}else
				if(lev[2] < brig[0]){
					lev[2] ++;
				}else
					if(lev[0] < brig[0]){
						lev[0] ++;
					}else
						if(lev[3] < brig[0]){
							lev[3] ++;
						}else
							if(lev[1] < brig[0]){
								lev[1] ++;
							}else
								if(lev[4] < brig[0]){
									lev[4] ++;
								}else{
									lev_dir = 2;
								}
		}

		sl_time = 0;
	}else

	if(fad[0] == 4 && sl_time++ > 5){
		for(Ts = 0; Ts < 6; Ts++){
			if(lev_dir == 0){
				if(digital[Ts] > 0) digital[Ts]--;
				else fad[1] |= (1 << Ts);

				if(fad[1] == 0x3F){
					lev_dir = 1;
					fad[1] = 0;

					Time_RD = 1;
				}
			}else

			if(lev_dir == 1){
				if(digital[Ts] < 9) digital[Ts]++;
				else fad[1] |= (1 << Ts);

				if(fad[1] == 0x3F){
					lev_dir = 2;
					fad[1] = 0;

					Time_RD = 1;
				}
			}else

			if(lev_dir == 2){
				if(digital[Ts] > tscr[Ts]) digital[Ts]--;
				else fad[1] |= (1 << Ts);

				if(fad[1] == 0x3F){
					lev_dir = 3;

					Time_RD = 1;

					fr[0] = 0x03;

					fad[0] = 0;
					fad[1] = 0;
				}
			}

		}

		sl_time = 0;
	}
 }
}

void display(){ //     , , 
	switch(screen){
		case 0: //Time
			soft(H, M, S);
			delay = 0;
		break;
		case 1:
			if(delay <= DELAY_TIME){
				soft(H, M, S);
			}else
				if(delay == DELAY_TIME+1){
					ds3231_get_date(&d, &m, &y);

					lev_dir = 0;

					fad[0] = 3;
					fad[1] = 0;
				}else
					if(delay > DELAY_TIME + DELAY_DATE){
						fad[0] = 4;
						fad[1] = 0;

						lev_dir = 0;

						delay = 0;
					}
		break;
		case 2:
			if(delay <= DELAY_TIME){
				soft(H, M, S);

				if(delay == DELAY_TIME){DS1820_Start_Conv();}
			}else
				if(delay == DELAY_TIME+1){
					fad[0] = 1;
				}
				else
					if(delay == DELAY_TIME + DELAY_TEMP){
						fad[0] = 2;
					}
		break;
		case 3:
			if(delay <= DELAY_TIME){
				soft(H, M, S);

				if(delay == DELAY_TIME){DS1820_Start_Conv();}
			}else
				if(delay == DELAY_TIME+1){
					ds3231_get_date(&d, &m, &y);

					lev_dir = 0;

					fad[0] = 3;
					fad[1] = 0;
				}else
					if(delay == DELAY_TIME + DELAY_DATE){
						fad[0] = 1;
					}else
						if(delay == DELAY_TIME + DELAY_DATE + DELAY_TEMP){
							fad[0] = 2;
						}
		break;

	}
}

uint8_t but[3] = {0, 0, 0};

void display_ret(){ //     
	delay = 0;

	lev[0] = 1; lev[1] = 1; lev[4] = 1; lev[5] = 1;
	lev[2] = 1; lev[3] = 1;

	ds3231_get_time(&H, &M, &S); //    RTC

	tscr[0] = H/10;
	tscr[1] = H%10;
	tscr[2] = M/10;
	tscr[3] = M%10;
	tscr[4] = S/10;
	tscr[5] = S%10;

	fr[0] = 0x3F;

	fad[0] = 0;
	fad[1] = 0;
}

void buttons(){ //   
	if(!BUT1){ // MENU
		if(but[0] > 20){
			set = 1;

			digital[4] = 0;
			digital[5] = 0;

			delay = 0;
		}else{
			but[0]++;
		}

		_delay_ms(100);
	}else{
		if(but[0] < 5 && but[0] != 0){
			screen++;

			if(screen == 4) screen = 0;

			fad[0] = 10;

			lev[0] = 0; lev[1] = 0; lev[4] = 0; lev[5] = 0;
			lev[2] = brig[0]; lev[3] = brig[0];

			digital[2] = 0;
			digital[3] = screen + 1;

			_delay_ms(1000);

			display_ret();

			Flash_save(screen, 1, 121);
		}

		but[0] = 0;
	}

	if(!BUT2){ // +
		if(but[1] < 21) but[1] ++;

		if(but[1] == 20){ // / 
			led[1] = !led[1];
			// col_ch 32 led1 1 led2 0
			s_data = 0;
			s_data |= (col_change << 2) | (led[1] << 1) | (led[2] << 0);
			Flash_save(s_data, 2, 121);
		}

		_delay_ms(100);
	}else{
		if(but[1] < 5 && but[1] != 0 && led[1] == 1){ // /  
			if(col_change & 1){
				col_change &= ~(1<<0);
			}else{
				col_change |= (1<<0);
			}

			s_data = 0;
			s_data |= (col_change << 2) | (led[1] << 1) | (led[2] << 0);
			Flash_save(s_data, 2, 121);

			if(!(col_change & 1)){
				Flash_save(R[0], 3, 122);
				Flash_save(G[0], 3, 123);
				Flash_save(B[0], 3, 124);
			}
		}

		but[1] = 0;
	}

	if(!BUT3){ // -
		if(but[2] < 21) but[2] ++;

		if(but[2] == 20){ // / 
			led[2] = !led[2];

			s_data = 0;
			s_data |= (col_change << 2) | (led[1] << 1) | (led[2] << 0);
			Flash_save(s_data, 2, 121);
		}

		_delay_ms(100);
	}else{
		if(but[2] < 5 && but[2] != 0){ // /  
			if(col_change & 2){
				col_change &= ~(1<<1);
			}else{
				col_change |= (1<<1);
			}

			s_data = 0;
			s_data |= (col_change << 2) | (led[1] << 1) | (led[2] << 0);
			Flash_save(s_data, 2, 121);


			Flash_save(R[1], 3, 125);
			Flash_save(G[1], 3, 126);
			Flash_save(B[1], 3, 127);
		}

		but[2] = 0;
	}
}

void settings(){ //  
	if(BUT1){
		but[0] = 0;
	}

	if(delay == 60){
		set = 0;
		display_ret();
	}

	if(!BUT1 && but[0] == 0){
		if(++set > 6){
			set = 0;

			ds3231_set_date(d, m, y);

			display_ret();
		}

		if(set == 3){
			ds3231_set_time(H, M, 0);

			S = 0;

			_delay_ms(200);

			ds3231_get_date(&d, &m, &y);

			digital[0] = d/10; digital[1] = d%10;
			digital[2] = m/10; digital[3] = m%10;
			digital[4] = y/10; digital[5] = y%10;

			set = 4;
		}

		delay = 0;

		lev[0] = brig[0]; lev[1] = brig[0];
		lev[2] = brig[0]; lev[3] = brig[0];
		lev[4] = brig[0]; lev[5] = brig[0];

		_delay_ms(300);
	}

	switch(set){
	case 1://Hour
		if(!BUT2){
			if(++H > 23){
				H = 0;
			}

			lev[0] = brig[0]; lev[1] = brig[0];

			delay = 0;

			digital[0] = H/10;
			digital[1] = H%10;

			_delay_ms(250);
		}else
			if(!BUT3){
				if(--H > 23){
					H = 23;
				}

				lev[0] = brig[0]; lev[1] = brig[0];

				delay = 0;

				digital[0] = H/10;
				digital[1] = H%10;

				_delay_ms(250);
			}

		if(CLOCK && BUT2 && BUT3){
			lev[0] = brig[0]/2; lev[1] = brig[0]/2;
		}else{
			lev[0] = brig[0]; lev[1] = brig[0];
		}
	break;

	case 2://Minutes
		if(!BUT2){
			if(++M > 60){
				M = 0;
			}

			lev[2] = brig[0]; lev[3] = brig[0];

			delay = 0;

			digital[2] = M/10;
			digital[3] = M%10;

			_delay_ms(250);
		}else
			if(!BUT3){
				if(--M > 60){
					M = 59;
				}

				lev[2] = brig[0]; lev[3] = brig[0];

				delay = 0;

				digital[2] = M/10;
				digital[3] = M%10;

				_delay_ms(250);
			}

		if(CLOCK && BUT2 && BUT3){
			lev[2] = brig[0]/2; lev[3] = brig[0]/2;
		}else{
			lev[2] = brig[0]; lev[3] = brig[0];
		}
	break;

	case 4://Day
		if(!BUT2){
			if(++d > 31){
				d = 0;
			}

			lev[0] = brig[0]; lev[1] = brig[0];

			delay = 0;

			digital[0] = d/10;
			digital[1] = d%10;

			_delay_ms(250);
		}else
			if(!BUT3){
				if(--d > 31){
					d = 23;
				}

				lev[0] = brig[0]; lev[1] = brig[0];

				delay = 0;

				digital[0] = d/10;
				digital[1] = d%10;

				_delay_ms(250);
			}

		if(CLOCK && BUT2 && BUT3){
			lev[0] = brig[0]/2; lev[1] = brig[0]/2;
		}else{
			lev[0] = brig[0]; lev[1] = brig[0];
		}
	break;

	case 5://Month
		if(!BUT2){
			if(++m > 12){
				m = 0;
			}

			lev[2] = brig[0]; lev[3] = brig[0];

			delay = 0;

			digital[2] = m/10;
			digital[3] = m%10;

			_delay_ms(250);
		}else
			if(!BUT3){
				if(--m > 12){
					m = 12;
				}

				lev[2] = brig[0]; lev[3] = brig[0];

				delay = 0;

				digital[2] = m/10;
				digital[3] = m%10;

				_delay_ms(250);
			}

		if(CLOCK && BUT2 && BUT3){
			lev[2] = brig[0]/2; lev[3] = brig[0]/2;
		}else{
			lev[2] = brig[0]; lev[3] = brig[0];
		}
	break;

	case 6://Year
		if(!BUT2){
			if(++y > 99){
				y = 16;
			}

			lev[4] = brig[0]; lev[5] = brig[0];

			delay = 0;

			digital[4] = y/10;
			digital[5] = y%10;

			_delay_ms(250);
		}else
			if(!BUT3){
				if(--y < 16){
					y = 99;
				}

				lev[4] = brig[0]; lev[5] = brig[0];

				delay = 0;

				digital[4] = y/10;
				digital[5] = y%10;

				_delay_ms(250);
			}

		if(CLOCK && BUT2 && BUT3){
			lev[4] = brig[0]/2; lev[5] = brig[0]/2;
		}else{
			lev[4] = brig[0]; lev[5] = brig[0];
		}
	break;
	}
}

void TIM2_IRQHandler(void){

 if(TIM2->SR & TIM_SR_UIF){
	TIM2->SR &= ~TIM_SR_UIF;

	sec = 0;

	TIM2->CR1 &= ~TIM_CR1_CEN;
  }
}

int main(){

	GPIO_init();

	I2C_init();

	_delay_ms(100);

	ds3231_init(1, 6);

	_delay_ms(500);

	DS1820_Start_Conv();
	_delay_ms(500);

	DS1820_Get_Temp(&temp_code, &subzero, &cel_frac_bits);
	Temp = DS1820_temp_to_decicel(subzero, temp_code, cel_frac_bits);

	r_data = Flash_read(121);

	uint16_t l, r[2], g[2], b[2], cn = 0;

	r[0] = Flash_read(122);
	g[0] = Flash_read(123);
	b[0] = Flash_read(124);

	r[1] = Flash_read(125);
	g[1] = Flash_read(126);
	b[1] = Flash_read(127);

	if(r[0] > 28000 || g[0] > 28000 || b[0] > 28000){
		r[0] = 0;
		g[0] = 5000;
		b[0] = 0;

		col_change = 0;
	}

	if(r[1] > 65200 || g[1] > 65200 || b[1] > 65200){
		r[1] = 0;
		g[1] = 0;
		b[1] = 20000;

		col_change = 0;
	}


	screen = r_data >> 8;

	if(screen > 3 || r_data == 0xFFFF){
		screen = 0;
		Flash_save(screen, 1, 121);
		led[1] = 1;
		led[2] = 1;
		col_change = 0;
	}else{
		col_change = (r_data>>2) & 0x0003;

		led[1] = (r_data >> 1) & 0x0001;

		led[2] = r_data & 0x0001;
	}

	TIM_Init();
	ADC_Init();

	fad[0] = 10;

	L_Level = ADC_Read();

	if(L_Level > 2020){ L_Level = 2020;}
	if(L_Level < 1220){ L_Level = 1220;}

	brig_tmp[1] = (2020-L_Level)/8+27;

	if((brig_tmp[0]+5) < brig_tmp[1]){
		brig_tmp[0] = brig_tmp[1];
	}else
		if((brig_tmp[0]) > brig_tmp[1]+5){
			brig_tmp[0] = brig_tmp[1];
		}

	digital[2] = 0;
	digital[3] = screen + 1;

	lev[0] = 0; lev[1] = 0; lev[4] = 0; lev[5] = 0;

	TIM6->CR1 &= ~TIM_CR1_CEN;

	for(l = 0; l < 65300; l++){

		if(R[0] < r[0]) R[0]++;
		if(G[0] < g[0]) G[0]++;
		if(B[0] < b[0]) B[0]++;

		if(R[1] < r[1]) R[1]++;
		if(G[1] < g[1]) G[1]++;
		if(B[1] < b[1]) B[1]++;

		if(cn++ >= 70){
			if(lev[2] < brig[0]){
				lev[2] ++;
				lev[3] ++;
			}

			cn = 0;
		}

		if(R[0]==r[0] && G[0]==g[0] && B[0]==b[0] && R[1]==r[1] && G[1]==g[1] && B[1]==b[1]){
			l = 65300;
		}

		_Delay_us(100);
	}

	for(l=0; lev[2] > 0; lev[2]--){
		lev[3]--;
		_delay_ms(50);
	}

	_delay_ms(500);

	TIM6->CR1 |= TIM_CR1_CEN;

	display_ret();

	while(1){

		if(Time_RD){ //  
			ds3231_get_time(&H, &M, &S);

			tscr[0] = H/10;
			tscr[1] = H%10;
			tscr[2] = M/10;
			tscr[3] = M%10;
			tscr[4] = S/10;
			tscr[5] = S%10;

			Time_RD = 0;
		}

		if(Temp_RD == 1){
			DS1820_Get_Temp(&temp_code, &subzero, &cel_frac_bits);
			Temp = DS1820_temp_to_decicel(subzero, temp_code, cel_frac_bits);

			Temp_RD = 0;
		}

		if(set == 0){
			buttons();
		}else{
			settings();
		}

		if(CLOCK && but[0] == 0){
			if(sec == 0){
				sec = 1; delay ++;

				TIM2->CNT = 0;
				TIM2->CR1 |= TIM_CR1_CEN;

				if(set == 0){

					if(++S >= 60){
						S = 0;
						if(++M >= 60){
							M = 0;
							if(++H >= 24){
								H = 0;
							}
						}
					}

					display();

					//       .   ,   
					L_Level = ADC_Read();

					if(L_Level > 2020){ L_Level = 2020;}
					if(L_Level < 1220){ L_Level = 1220;}

					brig_tmp[1] = (2020-L_Level)/8+27;

					if((brig_tmp[0]+5) < brig_tmp[1]){
						brig_tmp[0] = brig_tmp[1];
					}else
						if((brig_tmp[0]) > brig_tmp[1]+5){
							brig_tmp[0] = brig_tmp[1];
						}
				}
			}
		}/*else{
			sec = 0;
		}*/
	}

	return 0;
}
